<h2>Brief Overview</h2>

<ol>
  <li>
    To help preserve privacy (inc. with HD Wallets) and improve security, the
    Session established between Service and Wallet uses a Sandboxed Keypair
    generated using `sandboxedPrivateKey = hash256(masterPrivateKey +
    domainName)`.
  </li>
  <li>
    This PoC uses LibAuth templates. In future, these template can be hashed and
    whitelisted (trusted) by a wallet. For security, the service can only
    specify inputs and outputs by their corresponding scripts in the provided
    template (no raw locking/unlocking bytecode allowed).
  </li>
  <li>
    The service CAN request that the Wallet provides additional UTXOs to
    automatically meet the Satoshi and Token amounts that are summed in the
    outputs. In this respect, UTXO selection is done by the Wallet, but the
    Service can also provide inputs that it knows about.
  </li>
  <li>
    The Service CAN request a Wallet's UTXOs provided they a) contain tokens and
    b) access to those token category ID's have been granted upon Session
    Negotiation (`sessionProperties.allowedTokens` as an array of category ids
    or `*` for ALL tokens). This allows us to support token-specific use-cases
    (e.g. a particular NFT as input or more vague Crypto-Exchange use-cases).
  </li>
  <li>
    To prevent standards fracturing, the underlying RPC's are intended to be
    transport agnostic: They should be applicable to HTTP, LibP2P any other
    transports (not just WalletConnect). Thus, we should be able to use them for
    a future HTTP-based Payment Protocols, etc.
  </li>
  <li>
    The hope is that, in future, we will be able to converge with what BitJSON
    is building. The idea is that a wallet CAN (if the template is natively
    supported) save the data payloads and use the built-in Wallet UX to execute
    contract actions. But, for WC, the idea is that the SERVICE stores the data
    associated with a given WC account.
  </li>
  <li>
    There is currently no support for batching requests (or "actions"): We could
    build this, but BitJSON is working on something similar ("actions") and we
    should probably wait to see what his implementation looks like. These will
    likely replace specifying the transaction manually.
  </li>
  <li>
    Due to not having access to a wallet's UTXOs directly (with the exception of
    the tokens granted upon negotiation) and hence available source transaction
    hashes, minting new categories is a bit of a kludge. I'll try to provide
    more detail on this in the bch_signTransaction_V0 call.
  </li>
  <li>
    Type-hinting is currently hacked into a variable's description field. We
    want to think a little about how to handle this as they are not always
    static (e.g. using oracles.cash, we may set a price - but we want that to
    show depending upon which Oracle was chosen in another variable according to
    the scaling factor).
  </li>
  <li>
    Currently, the `bch_signTransaction_V0` RPC returns redeem scripts for the
    compiled outputs, but we want to return resolved variables instead (I think
    this'll both simplify things and potentially allow us to support multisig).
  </li>
  <li>
    Accounts are currently identified by address - but there are some benefits
    we may gain if we use the Public Key instead (e.g. ability to sign and
    encrypt.
  </li>
</ol>
